.\"	$NetBSD: fpclassify.3,v 1.2 2004/01/15 19:43:45 kleink Exp $
.\"
.\" Copyright (c) 2003 The NetBSD Foundation, Inc.
.\" All rights reserved.
.\"
.\" This code is derived from software contributed to The NetBSD Foundation
.\" by Klaus Klein.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE NETBSD FOUNDATION, INC. AND CONTRIBUTORS
.\" ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
.\" TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
.\" PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE FOUNDATION OR CONTRIBUTORS
.\" BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
.\" CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
.\" SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
.\" INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
.\" CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
.\" ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
.\" POSSIBILITY OF SUCH DAMAGE.
.\"
.Dd January 14, 2004
.Dt FPCLASSIFY 3
.Os
.Sh NAME
.Nm fpclassify
.Nd classify real floating type
.Sh LIBRARY
.Lb libc
.Sh SYNOPSIS
.In math.h
.Ft int
.Fn fpclassify "real-floating x"
.Sh DESCRIPTION
The
.Fn fpclassify
macro performs classification of its argument
.Fa x .
An argument represented in a format wider than its semantic type is
converted to its semantic type first.
The classification is then based on the type of the argument.
.Ss IEEE 754
.Bl -tag -width "FP_SUBNORMALXXX" -compact -offset indent
.It Dv FP_INFINITE
infinity, either positive or negative
.It Dv FP_NAN
not-a-number
.Pq Dq NaN
.It Dv FP_NORMAL
normal
.It Dv FP_SUBNORMAL
subnormal
.It Dv FP_ZERO
zero
.El
.Ss VAX
.Bl -tag -width "FP_DIRTYZEROXXX" -compact -offset indent
.It Dv FP_ROP
reserved operand
.Pq Dq ROP
.It Dv FP_DIRTYZERO
dirty zero
.It Dv FP_NORMAL
finite
.It Dv FP_ZERO
true zero
.El
.Sh RETURN VALUES
The
.Fn fpclassify
macro returns the value of the number classification macro appropriate
to its argument
.Fa x
as described above.
.Sh ERRORS
No errors are defined.
.Sh SEE ALSO
.Xr isfinite 3 ,
.Xr isnormal 3 ,
.Xr math 3 ,
.Xr signbit 3
.Sh STANDARDS
The
.Fn fpclassify
macro conforms to
.St -isoC-99 .
